<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/ThreadManagerBase.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_thread_manager_base_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ThreadManagerBase.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerBase.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;Data.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerSingle.h&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerPowerSaver.h&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;ThreadManagerEager.h&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">   11</a></span>&#160;    std::unique_ptr&lt;ThreadManagerBase&gt; <a class="code" href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">ThreadManagerBase::Factory</a> (ThreadingPolicy policy, <a class="code" href="structsiggen_1_1_data.html">Data</a> &amp;&amp; data)</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keywordflow">switch</span> (policy)</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        {</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;            <span class="keywordflow">case</span> SingleThread:</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;            {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;                LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Creating ThreadManagerSingle&quot;</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;                std::unique_ptr&lt;ThreadManagerBase&gt; ptr(<span class="keyword">new</span> <a class="code" href="classsiggen_1_1_thread_manager_single.html">ThreadManagerSingle</a>(std::move(data)));</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;                <span class="keywordflow">return</span> ptr;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;            }</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;            <span class="keywordflow">case</span> PowerSaver:</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;                LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Creating ThreadManagerPowerSaver&quot;</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;                std::unique_ptr&lt;ThreadManagerBase&gt; ptr(<span class="keyword">new</span> <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html">ThreadManagerPowerSaver</a>(std::move(data)));</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;                <span class="keywordflow">return</span> ptr;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            }</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            <span class="keywordflow">case</span> Eager:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Creating ThreadManagerEager&quot;</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                std::unique_ptr&lt;ThreadManagerBase&gt; ptr(<span class="keyword">new</span> <a class="code" href="classsiggen_1_1_thread_manager_eager.html">ThreadManagerEager</a>(std::move(data)));</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                <span class="keywordflow">return</span> ptr;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            }</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        }</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;cannot create ThreadManager instance&quot;</span>);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    }</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;} <span class="comment">// namespace siggen</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_thread_manager_single_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager_single.html">siggen::ThreadManagerSingle</a></div><div class="ttdoc">single-thread signature generator</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_single_8h_source.html#l00009">ThreadManagerSingle.h:9</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_base_html_acb6c87062d2f75f4ad9d21801950e61e"><div class="ttname"><a href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">siggen::ThreadManagerBase::Factory</a></div><div class="ttdeci">static std::unique_ptr&lt; ThreadManagerBase &gt; Factory(ThreadingPolicy policy, Data &amp;&amp;data)</div><div class="ttdoc">creates threading manager according to ThreadingPolicy</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_base_8cpp_source.html#l00011">ThreadManagerBase.cpp:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html">siggen::ThreadManagerPowerSaver</a></div><div class="ttdoc">default thread manager using mutexes and condition variables</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8h_source.html#l00016">ThreadManagerPowerSaver.h:16</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html"><div class="ttname"><a href="structsiggen_1_1_data.html">siggen::Data</a></div><div class="ttdoc">provides threading manager with necessary data to work with</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00012">Data.h:12</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_eager_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager_eager.html">siggen::ThreadManagerEager</a></div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_eager_8h_source.html#l00007">ThreadManagerEager.h:7</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>ThreadManagerBase.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
